#
# Create the jUDDI database
#

DROP DATABASE IF EXISTS cgl_wscontext;
CREATE DATABASE cgl_wscontext;

#
# Sets global privileges to user maktas
#

REPLACE INTO mysql.user SET 
  Host = '%', # any hostname (including localhost)
  # alternatively '192.168.0.1/255.255.255.0', '129.%', 'localhost'
  User = 'maktas',
  Password = PASSWORD('cgl_wscontext'),
  Select_priv = 'Y',
  Insert_priv = 'Y', 
  Update_priv = 'Y', 
  Delete_priv = 'Y', 
  Create_priv = 'Y', 
  Drop_priv = 'Y', 
  Reload_priv = 'Y', 
  Shutdown_priv = 'Y', 
  Process_priv = 'Y', 
  File_priv = 'Y', 
  Grant_priv = 'Y', 
  References_priv = 'Y', 
  Index_priv = 'Y', 
  Alter_priv = 'Y'
;

FLUSH PRIVILEGES; 



#
# Optionaly Set db provilege and host privileges
# This should be used if the juddi user should not 
# have global privileges. In detail mysql access control
# is calculated as follows:
#   global privileges
#   OR (database privileges AND host privileges)
#   OR table privileges
#   OR column privileges
#

INSERT INTO mysql.db SET 
  Host = '%', # if blank intersect with the mysql.host record
  Db = 'cgl_wscontext%', 
  User = 'maktas', 
  Select_priv = 'Y', Insert_priv = 'Y', 
  Update_priv = 'Y', Delete_priv = 'Y', 
  Create_priv = 'Y', Drop_priv = 'Y',
  Grant_priv = 'N', References_priv = 'Y', 
  Index_priv = 'Y', Alter_priv = 'Y'
;

INSERT INTO mysql.host SET
  Host = '%',
  Db = 'cgl_wscontext%',
  Select_priv = 'Y', Insert_priv = 'Y',
  Update_priv = 'Y', Delete_priv = 'Y',
  Create_priv = 'N', Drop_priv = 'N',
  Grant_priv = 'N', References_priv = 'N',
  Index_priv = 'N', Alter_priv = 'N'
;


#
# create the jUDDI tables
#
USE cgl_wscontext;
SOURCE cgl_wscontext_database_second_script.sql;

#
# add a jUDDI publisher
#
# PUBLISHER_ID  The user ID the publisher uses when authenticating.
# IMPORTANT: This should be the same value used to authenticate 
# with the external authentication service. 
# PUBLISHER_NAME The publisher's name (or in UDDI speak the
# Authorized Name). 
# ADMIN Indicate if the publisher has administrative privileges.
# Valid values for this column are 'true' or 'false'. The ADMIN 
# value is currently not used.

INSERT INTO PUBLISHER (PUBLISHER_ID,PUBLISHER_NAME,ADMIN) 
  VALUES ('maktas','Mehmet Aktas','true');


