CREATE DATABASE cgl_wscontext_deneme;

GRANT ALL ON cgl_wscontext_deneme.* TO uddi_user@"%" IDENTIFIED BY "changeIt";
GRANT ALL ON cgl_wscontext_deneme.* TO uddi_user@"localhost" IDENTIFIED BY "changeIt";

USE cgl_wscontext_deneme;

DROP TABLE IF EXISTS AUTH_TOKEN;
CREATE TABLE AUTH_TOKEN
(
  AUTH_TOKEN VARCHAR(61) NOT NULL,
  PUBLISHER_ID VARCHAR(20) NOT NULL,
  PUBLISHER_NAME VARCHAR(255) NOT NULL,
  CREATED TIMESTAMP NOT NULL,
  LAST_USED TIMESTAMP NOT NULL,
  NUMBER_OF_USES INT NOT NULL,
  TOKEN_STATE INT NOT NULL,
  PRIMARY KEY (AUTH_TOKEN)
);

DROP TABLE IF EXISTS PUBLISHER;
CREATE TABLE PUBLISHER
(
  PUBLISHER_ID VARCHAR(20) NOT NULL,
  PUBLISHER_NAME VARCHAR(255) NOT NULL,
  LAST_NAME VARCHAR(150) NULL,
  FIRST_NAME VARCHAR(100) NULL,
  MIDDLE_INIT VARCHAR(5) NULL,
  WORK_PHONE VARCHAR(50) NULL,
  MOBILE_PHONE VARCHAR(50) NULL,
  PAGER VARCHAR(50) NULL,
  EMAIL_ADDRESS VARCHAR(255) NULL,
  ADMIN VARCHAR(5) NULL,
  ENABLED VARCHAR(5) NULL,
  PRIMARY KEY (PUBLISHER_ID)
);

DROP TABLE IF EXISTS CONTEXT_ASSERTION;
CREATE TABLE CONTEXT_ASSERTION
(
  PROPERTY_KEY VARCHAR(61)  NOT NULL,
  FROM_KEY VARCHAR(61) NOT NULL,
  PROPERTY_URI VARCHAR(255) NOT NULL,  
  TO_KEY VARCHAR(61) NOT NULL,
  PRIMARY KEY (PROPERTY_KEY)
);

DROP TABLE IF EXISTS CONTEXT_ENTITY;
CREATE TABLE CONTEXT_ENTITY
(
    CONTEXT_KEY VARCHAR(61) NOT NULL,
    CONTEXTTYPE VARCHAR(61) NULL,
    OWNER_PUBLISHERID VARCHAR(128) NULL,
    OWNER_AUTH_INFO VARCHAR(100) NULL,
    GROUP_AUTH_INFO VARCHAR(100) NULL,
    OTHERS_AUTH_INFO VARCHAR(100) NULL,
    CONTEXTVALUEXML BLOB NULL,
    CONTEXTVERSION INT NULL,
    PRIMARY KEY (CONTEXT_KEY)
);

DROP TABLE IF EXISTS CONTEXT_NAME;
CREATE TABLE CONTEXT_NAME
(
  CONTEXT_KEY VARCHAR(61) NOT NULL,
  CONTEXT_NAME_ID INT NOT NULL,
  LANG_CODE VARCHAR(2) NULL,
  NAME VARCHAR(255) NOT NULL,
  PRIMARY KEY (CONTEXT_KEY,CONTEXT_NAME_ID),
  FOREIGN KEY (CONTEXT_KEY)
    REFERENCES CONTEXT_ENTITY (CONTEXT_KEY)
);

DROP TABLE IF EXISTS CONTEXT_PUBLISHER;
CREATE TABLE CONTEXT_PUBLISHER
(
  CONTEXT_KEY VARCHAR(61)  NOT NULL,
  PUBLISHER_ID VARCHAR(61) NOT NULL,
  LAST_UPDATE TIMESTAMP NOT NULL,
  PRIMARY KEY (CONTEXT_KEY)
);

DROP TABLE IF EXISTS LEASE;
CREATE TABLE LEASE
(
    OBJECT_KEY VARCHAR(61) NOT NULL,
    LEASEAPPLIEDONDATE DATE NULL,
    LEASESTARTFROMDATE DATE NULL,
    LEASEEXPIRATIONDATE DATE NULL,
    LEASELASTRENEWALDATE DATE NULL,
    ISINFINITE VARCHAR(5) NULL,
    PRIMARY KEY (OBJECT_KEY)
);

DROP TABLE IF EXISTS SESSION_ENTITY;
CREATE TABLE SESSION_ENTITY
(
  SESSION_KEY VARCHAR(61) NOT NULL,
  AUTHORIZED_NAME VARCHAR(255) NOT NULL,
  PUBLISHER_ID VARCHAR(20) NULL,
  OPERATOR VARCHAR(255) NOT NULL,
  LAST_UPDATE TIMESTAMP NOT NULL,
  PRIMARY KEY (SESSION_KEY)
);

DROP TABLE IF EXISTS SESSION_CONTEXT;
CREATE TABLE SESSION_CONTEXT
(
  SESSION_KEY VARCHAR(61) NOT NULL,
  CONTEXT_KEY VARCHAR(61) NOT NULL,
  LAST_UPDATE TIMESTAMP NOT NULL,
  PRIMARY KEY (CONTEXT_KEY),
  FOREIGN KEY (SESSION_KEY)
    REFERENCES SESSION_ENTITY (SESSION_KEY)
);

DROP TABLE IF EXISTS SESSION_DESCR;
CREATE TABLE SESSION_DESCR
(
  SESSION_KEY VARCHAR(61) NOT NULL,
  SESSION_DESCR_ID INT NOT NULL,
  LANG_CODE VARCHAR(2) NULL,
  DESCR VARCHAR(255) NOT NULL,
  PRIMARY KEY (SESSION_KEY,SESSION_DESCR_ID),
  FOREIGN KEY (SESSION_KEY)
    REFERENCES SESSION_ENTITY (SESSION_KEY)
);

DROP TABLE IF EXISTS SESSION_NAME;
CREATE TABLE SESSION_NAME
(
  SESSION_KEY VARCHAR(61) NOT NULL,
  SESSION_NAME_ID INT NOT NULL,
  LANG_CODE VARCHAR(2) NULL,
  NAME VARCHAR(255) NOT NULL,
  PRIMARY KEY (SESSION_KEY,SESSION_NAME_ID),
  FOREIGN KEY (SESSION_KEY)
    REFERENCES SESSION_ENTITY (SESSION_KEY)
);

DROP TABLE IF EXISTS SESSION_SERVICE;
CREATE TABLE SESSION_SERVICE
(
  SESSION_KEY VARCHAR(61) NOT NULL,
  SERVICE_KEY VARCHAR(61) NOT NULL,
  LAST_UPDATE TIMESTAMP NOT NULL,
  PRIMARY KEY (SERVICE_KEY),
  FOREIGN KEY (SESSION_KEY)
    REFERENCES BUSINESS_ENTITY (SESSION_KEY)
);

DROP TABLE IF EXISTS SERVICE_CONTEXT;
CREATE TABLE SERVICE_CONTEXT
(
  SERVICE_KEY VARCHAR(61) NOT NULL,
  CONTEXT_KEY VARCHAR(61) NOT NULL,
  LAST_UPDATE TIMESTAMP NOT NULL,
  PRIMARY KEY (CONTEXT_KEY),
  FOREIGN KEY (SERVICE_KEY)
    REFERENCES SESSION_SERVICE (SERVICE_KEY)
);

INSERT INTO PUBLISHER (PUBLISHER_ID,PUBLISHER_NAME,ADMIN) 
  VALUES ('uddi_user','Mehmet Aktas','true');