/*
 * Copyrights 2001-2006 CGL.
 *
 */

import java.io.*;
import cgl.narada.event.NBEvent;
import cgl.util.BootStrap;
import java.util.Properties;
import cgl.axis.services.WSCTX.uddi_wsctx_schema.Context;
import cgl.axis.services.uddi.uddi_schema.Name;
import cgl.narada.service.client.ClientService;
import cgl.narada.service.client.SessionService;
import cgl.narada.service.ServiceException;
import cgl.narada.event.TemplateProfileAndSynopsisTypes;
import cgl.narada.service.client.EventConsumer;
import cgl.narada.service.client.NBEventListener;
import cgl.narada.matching.Profile;
import java.util.Random;

/**
 * @author Mehmet S. Aktas (maktas@indiana.edu)
 * @author Hasan Bulut (hbulut@indiana.edu)
 */

public class ContextListener implements NBEventListener {

    private Object synchObj = new Object();
    private static Properties bootstrap = null;
    private String hostName = null;
    private String portNum = null;
    private Random generator = null;
    private static ContextListener nb_subscriber = null;
    private ClientService clientService = null;
    private int entityId;
    private String serviceConfigPath = "properties.properties";
    private EventConsumer listener = null;
    Profile profile = null;


    public ContextListener() {
        // Load bootsrap configuration
        try {
                bootstrap = BootStrap.loadProperties("properties.properties");
        } catch (Exception ex) {

        }
        try {
            this.hostName = bootstrap.getProperty("hostname");
            this.portNum = bootstrap.getProperty("portnum");
            generator = new Random(System.currentTimeMillis());
            entityId = generator.nextInt(1000000);
            String endpoint = "niotcp://" + this.hostName + ":" + this.portNum;
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    public void initBroker() {
        try {
            SessionService.setServiceConfigurationLocation(serviceConfigPath);
            clientService = SessionService.getClientService(entityId);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        try {
            clientService.initializeBrokerCommunications(bootstrap, "niotcp");
            // initializeTransmitter();
            // connector.initializeReceiver();
        } catch (ServiceException ex) {
            ex.printStackTrace();
       }
    }

    public void onEvent(NBEvent nbEvent) {
        System.out.println("NBEvent received:");
        synchronized (synchObj) {
            Context context = null;
            context = (Context)this.deserializeObject(nbEvent.getContentPayload());
            printContext(context);
        }
    }

    private void subscribe(String topic) {
        try {
            listener = clientService.createEventConsumer(this);
            profile = clientService.createProfile(TemplateProfileAndSynopsisTypes.STRING, topic);
            listener.subscribeTo(profile);
        } catch (ServiceException ex) {
        }

    }

    /**
     * This function is to print context object to Console.
     */
    public void printContext(Context context) {
        if (context != null) {
            System.out.println(
                    "********* PRINT Context ***********");
            System.out.println("saved context_key = " +
                               context.getContextKey());
            System.out.println("context operation type = " +
                               context.getValueType());
            Name[] returned_name_array = context.getName();
            if (returned_name_array != null &&
                returned_name_array.length != 0) {
                System.out.println("context user identifer = " +
                                   returned_name_array[0].getValue());
            }
            System.out.println("context session key = " +
                               context.getSessionKey());
            String data = new String(context.getValue());
            System.out.println("context DATA = " + data);
        }
    }


    protected Object deserializeObject(byte[] bytes) {
        Object obj = null;
        try {
            ObjectInputStream in = new ObjectInputStream(new
                    ByteArrayInputStream(
                            bytes));
            obj = in.readObject();
            in.close();
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (ClassNotFoundException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return obj;
    }

    protected byte[] serializeObject(Object object) {
        ByteArrayOutputStream bos = new ByteArrayOutputStream();
        try {
            ObjectOutput out = new ObjectOutputStream(bos);
            out.writeObject(object);
            out.close();
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } // Get the bytes of the serialized object
        return bos.toByteArray();
    }


    public static void main(String[] args) {
        ContextListener cp = new ContextListener();
        cp.initBroker();
        cp.subscribe("/uuid:EE91FBF0-6FFB-11DA-A022-C6453A8B4EE7-1134933879109");
    }
}
